/*
Some test for bpmn2xtt module.

Predicates: go, test1, test1a, test2, test3 and example
are testing predicates.
Input and generated files are located in ./test directory.
Input files are *.bpmn; expexted results are located in *.pl files in same directory.
Each call to any testing predicated will averride the old expected result.
Using tool e.g. like subversion user can compare the expected and actual result.
*/

:-ensure_loaded(bpmn2xtt).


go:-
	test_bpmn_to_xtt('exclusive_s.bpmn','exclusive_s.pl'),
	test_bpmn_to_xtt('exclusive_j.bpmn','exclusive_j.pl'),
	test_bpmn_to_xtt('parallel_s.bpmn','parallel_s.pl'),
	test_bpmn_to_xtt('parallel_j.bpmn','parallel_j.pl'),
	halt.

test1:-
	test_bpmn_to_xtt('example_process.bpmn','example_process.pl'),
	halt.
test1a:-
	bpmn_atts_names,
	test_bpmn_to_xtt('example_process.bpmn','example_process_atts_names.pl'),
	halt.

test2:-
	bpmn_atts_names,
	test_bpmn_to_xtt('ATM_noloop.bpmn','atm.pl'),
	halt.

test3:-
	dotest('actvs'),
	halt.


example:-
	dotest('exclusive_split_join').









test_bpmn_to_xtt(BpmnFile,XttFile):-
	testsdir(BpmnFile,B),
	testsdir(XttFile,X),
	bpmn_to_xtt(B,X).

testsdir(File,DFile):-
	atomic_list_concat(['tests/',File],DFile).

dotest(Name):-
	bpmn_atts_names,
	atomic_list_concat([Name,'.bpmn'],BpmnFile),
	atomic_list_concat([Name,'.pl'],XttFile),
	test_bpmn_to_xtt(BpmnFile,XttFile).








