%%%%%%%%%%%%%%	Attributes Types	%%%%%%%%%%%%%%%%

xtype [name:tpe_bpmn_entit,base:symbolic,length:4,scale:0,desc:'bpmn entity 1 - executed, null - not executed',domain:[null,1]].
xtype [name:integer,base:numeric,length:10,scale:0,desc:integer,domain:[-2147483648 to 2147483647]].


%%%%%%%%%%%%%%	Attributes	%%%%%%%%%%%%%%%%

xattr[name:'entry task',abbrev:'entry task1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f1,abbrev:f11,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f2,abbrev:f21,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:start,abbrev:start1,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f3,abbrev:f31,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f4,abbrev:f41,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f5,abbrev:f51,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:v,abbrev:v1,class:simple,type:integer,comm:inter,callback:[get_v,[v]]].
xattr[name:'1-2 task',abbrev:'1-2 task1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f6,abbrev:f61,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'default task',abbrev:'default task1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f7,abbrev:f71,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f8,abbrev:f81,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f9,abbrev:f91,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f10,abbrev:f101,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f11,abbrev:f111,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'parallel task 1',abbrev:'parallel task 11',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f12,abbrev:f121,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'parallel task 2',abbrev:'parallel task 21',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f13,abbrev:f131,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f14,abbrev:f141,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'middle task',abbrev:'middle task1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:end,abbrev:end1,class:simple,type:tpe_bpmn_entit,comm:inter].


%%%%%%%%%%%%%%	XTT Tables	%%%%%%%%%%%%%%%%

xschm 'xtt_entry task': [f1] ==> [f2,'entry task'].
xschm xtt_start: [] ==> [f1,start].
xschm xtt_g1: [f2,v] ==> [f3,f4,f5].
xschm 'xtt_1-2 task': [f3,v] ==> [f6,'1-2 task'].
xschm 'xtt_default task': [f5] ==> [f7,'default task'].
xschm xtt_g2: [f6,f7,f8] ==> [f9].
xschm xtt_g3: [f9] ==> [f10,f11].
xschm 'xtt_parallel task 1': [f10] ==> [f12,'parallel task 1'].
xschm 'xtt_parallel task 2': [f11] ==> [f13,'parallel task 2'].
xschm xtt_g4: [f12,f13] ==> [f14].
xschm 'xtt_middle task': [f4,v] ==> [f8,'middle task'].
xschm xtt_end: [f14] ==> [end].


xrule 'xtt_entry task'/1: [f1 eq 1] ==> ['entry task' set 1,f2 set 1] **> [['on_entry task',['entry task']]].
xrule xtt_start/1: [] ==> [f1 set 1] **> [[on_start,[start]]].
xrule xtt_g1/1: [f2 eq 1,v in [1,2]] ==> [f3 set 1].
xrule xtt_g1/2: [f2 eq 1,f3 eq null,v in [3]] ==> [f4 set 1].
xrule xtt_g1/3: [f2 eq 1,f3 eq null,f4 eq null] ==> [f5 set 1].
xrule 'xtt_1-2 task'/1: [f3 eq 1,v in [1,2]] ==> ['1-2 task' set 1,f6 set 1] **> [['on_1-2 task',['1-2 task']]].
xrule 'xtt_default task'/1: [f5 eq 1] ==> ['default task' set 1,f7 set 1] **> [['on_default task',['default task']]].
xrule xtt_g2/1: [f6 eq 1] ==> [f9 set 1].
xrule xtt_g2/2: [f7 eq 1] ==> [f9 set 1].
xrule xtt_g2/3: [f8 eq 1] ==> [f9 set 1].
xrule xtt_g3/1: [f9 eq 1] ==> [f10 set 1,f11 set 1].
xrule 'xtt_parallel task 1'/1: [f10 eq 1] ==> ['parallel task 1' set 1,f12 set 1] **> [['on_parallel task 1',['parallel task 1']]].
xrule 'xtt_parallel task 2'/1: [f11 eq 1] ==> ['parallel task 2' set 1,f13 set 1] **> [['on_parallel task 2',['parallel task 2']]].
xrule xtt_g4/1: [f12 eq 1,f13 eq 1] ==> [f14 set 1].
xrule 'xtt_middle task'/1: [f4 eq 1,v in [3]] ==> ['middle task' set 1,f8 set 1] **> [['on_middle task',['middle task']]].
xrule xtt_end/1: [f14 eq 1] ==> [end set 1] **> [[on_end,[end]]].


xstat s1:[].




%%%%%%%%%%%%%%	Callbacks Stubs	%%%%%%%%%%%%%%%%

%%%%	Rules Callbacks	%%%%

xactn 'on_entry task': ['entry task'] >>> writeln('on_entry task'). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_start: [start] >>> writeln(on_start). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn 'on_1-2 task': ['1-2 task'] >>> writeln('on_1-2 task'). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn 'on_default task': ['default task'] >>> writeln('on_default task'). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn 'on_parallel task 1': ['parallel task 1'] >>> writeln('on_parallel task 1'). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn 'on_parallel task 2': ['parallel task 2'] >>> writeln('on_parallel task 2'). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn 'on_middle task': ['middle task'] >>> writeln('on_middle task'). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_end: [end] >>> writeln(on_end). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.


%%%%	Attributes Callbacks	%%%%

xcall get_v: [v] >>> (writeln(get_v),read(Answer), alsv_new_val(v,Answer)).
