% This module requires BankDatabase odbc data source
% user: testuser, no password
%
% data base creation scripts are located in schema directory (schema/ATM.sql, schema/ATM_data.sql)

:-use_module('paths').
:-use_module(db(db)).

dsn(DSN):-
	DSN = 'BankDatabase'.

% open and initialize database connection
initialize:-
	dsn(DSN),
	db_open(DSN,testuser,''),
	at_halt(finalize),
	
	% do not show generated SQL queries in stdout
	set_db_flag(show_query,off),

	%% database access predicates definition
	%db_import(tablename(columns),prolog_predicate)
	
	db_import('clients'('id','first_name','last_name'),
				client),

	db_import('accounts'('id','amount'),
				account),
	
	db_import('clients_accounts'('client','account'),
				client_account),

	db_import('cards'('id','account','client','pin'),
				card),
	
	% join of cards and accounts tables
	db_query(card_account(CrdId,CrdPin,AcId,AcAmount),
		(card(CrdId,AcId,_,CrdPin),
		 account(AcId,AcAmount))
		).

% close database connection
finalize:-
	dsn(DSN),
	db_close(DSN).

:-initialize.










