/*
This test remains ODBC data source named xsbOdbcPort configured
and underlaying database server running (postgresql)
*/

:-use_module('../paths').
:-use_module(db).
:-use_module(utils(term_utils)).

%% data base name: xsb-db-test

test1go :-db_open(xsbOdbcPort, skeno, ''),

    drop,


    create,

    %trzeba dolozyc obsluge modulow
    db_import('table1'('id', 'name'), table_one),!,

    db_insert(table_one_insert(Id, Name), (table_one(Id, Name))),!,
	table_one_insert(1, 'name1'),
	table_one_insert(2, 'name2'),
	table_one_insert(3, 'name3'),

   table_one(_, _),




    db_import('table2'('tab1_id', 'name'), table_detail),!,

    db_insert(table_detail_ins(Tab1_id, Name), table_detail(Tab1_id, Name)),!,
	table_detail_ins(1, datail11),
	table_detail_ins(1, detail12),
	table_detail_ins(3, detail31),

    table_detail(_, _),



    db_query(join(Id, Name, DetailName), (
					 table_one(Id, Name),
					 table_detail(Id, DetailName)
					 )),!,
    list,

    db_query(jt(Id, Name, DN), (
				table_one(Id, Name),
				not(table_one(1, 'name1')),
				table_detail(Id, DN)
			       ), findall(true)),!,

    findall( Id ,jt(Id, Name, DetailName), Id1s), print(Id1s),


    db_query(jt2(Id, Name, DN), (
				table_one(Id, Name),
				not(Id = 1),
				not('name1' = Name),
				table_detail(Id, DN)
			       ), findall(true)),!,

    findall( Id, jt2(Id, Name, DetailName), Id2s), print(Id2s),



    %% UPDATE table_one SET Name = 'Jozek' Where Id = 1
    db_update([Name='Jozek'], (table_one(Id,Name), [Id=1])),

    db_delete(table_one_del(Id, Name), (table_one(Id, Name), Id > 1, Id < 3)),
	table_one_del(1, _),
	table_one_del(2, _),
	table_one_del(3, name3),

    list_s,

    db_close(defaultConnection).

my_catch(G, M):-
	catch(G, E, (write('error on '), write(M), write(' '), writeln(E))).

drop :- my_catch(db_sql([], 'DROP TABLE table2', _), 'DROP TABLE'),
	    my_catch(db_sql([], 'DROP TABLE table1', _), 'DROP TABLE' ).

create :-
	my_catch(
	db_create_table('table1', (
			    'id integer not null,
			    name text,
			    PRIMARY KEY(id)')), 'CREATE TABLE 1'),
	my_catch(db_create_table('table2', (
			    'tab1_id integer,
			    name text,
			    FOREIGN KEY(tab1_id) REFERENCES table1(id)'
			    )), 'CREATE TABLE 2'
	      ).


list_s:-writeln('after delete :'), join(_, _, _) = T, T, writeln(T), fail.
list_s.
list :- writeln('before delete:'), join(_, _, _) = T, T, writeln(T), fail.
list.


%:- gtrace, go.


%%%% UPDATE TESTS

odbc_source(Odbc):-
	Odbc = 'BankDatabase'.

testinitialize:-
	odbc_source(Source),
	db_open(Source,testuser,''),
	at_halt(testfinalize),

	%% database access predicates definition

	%db_import(tablename(listofcolumns),prolog_predicate_name)
	db_import('clients'('id','first_name','last_name'),client),

	db_import('accounts'('id','amount'), account),
	db_import('clients_accounts'('client','account'),client_account),

	db_import('cards'('id','account','client','pin'),card),
	db_query(card_account(CardId,CardPin,AccountId,AccountAmount),
		(card(CardId,AccountId,_ClientId,CardPin),
		 account(AccountId,AccountAmount))
		),
	!.

testfinalize:-
	db_close(defaultConnection).

%:-testinitialize.

test:-
	db_update((Id=1,CardPin=2),(
					    card(Id,_AcId,_ClId,CardPin),
					    [Id=10])
		 ).


test2:-
	db_update((CardPin=5678),(
				  card(Id,_AcId,_ClId,CardPin),
				  Id > 0
				 )).

test4:-
	db_update((CardPin=5678),(card(_Id,_AcId,_ClId,CardPin)), [rows_affected(Number)]),
	writef('Rows affected number is: %w', [Number]).











