:-module(paths, []).

:-dynamic main_dir/1.

set_path(Alias, Path):-
	main_dir(MainDir),
	atomic_list_concat([MainDir, '/', Path], PathFromMain),
	absolute_file_name(PathFromMain, AbsPath),
	\+ user:file_search_path(Alias, AbsPath),
	assert(user:file_search_path(Alias, AbsPath)),

	atomic_list_concat([Alias, ': ', AbsPath], Msg), writeln(Msg).

paths:-
	\+ main_dir(_),!,
	'$current_module'(paths, ThisModulePath),
	file_directory_name(ThisModulePath, MainDir),
	assert(main_dir(MainDir)),

	set_path(hheart, './heart-m3-b'),
	set_path(bpmn2xtt, './bpmn2xtt'),
	set_path(utils, './utils'),
	set_path(db, './db').
	
paths.  % already loaded


:-paths.

